Foreman - Bug #19990

Failed to update a compute vmware (VMware) instance node.test.domain: undefined method '[]' for
nil:NilClass

06/13/2017 05:07 AM - Christian MeiB3ner

Status: Closed
Priority: Normal
Assignee: Ondfrej Prazak
Category: Compute resources - VMware
Target version: 1.18.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases: 1.16.1
Bugzilla link: 1551014 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/5577,
https://github.com/theforeman/foreman/p
ull/5626,
https://github.com/theforeman/foreman/p
ull/5627
Description

If | try to update the environment of a machine in a vmware compute instance i get the above error.
| attached the sanitized debug output of the following command.

hammer -u user -p pass -d host update --id 127 --environment production

If | use --environment-id instead of --environment it leads to the same error.

Other actions for example start and stop of a virtual machine works fine.

Related issues:
Copied to Foreman - Bug #23752: VMWare allow save vm w/o size_gb attr (1.16.2) Closed 05/31/2018

Associated revisions

Revision 1dbb2c5b - 05/31/2018 07:24 AM - Steve Miller

Fixes #19990 - VMWare allow save vm w/o size_gb attr

History

#1 - 06/13/2017 10:55 AM - Tomas Strachota

Hello Christian,

thank you for reporting the issue. Attached hammer logs show that the error occurs on the server side. May | ask you to attach relevant part of
foreman logs too?

If you try to perform the same action in the Ul, does it fail with the same error?

#2 - 06/14/2017 01:11 AM - Christian MeiBner

- File production.log added

Tomas Strachota wrote:
Hello Christian,
thank you for reporting the issue. Attached hammer logs show that the error occurs on the server side. May | ask you to attach relevant part of
foreman logs too?

Hi Tomas attached you can find the cut off of our production.log.

If you try to perform the same action in the Ul, does it fail with the same error?
No, in the Ul it works pretty good.

#3 - 06/14/2017 05:18 AM - Tomas Strachota
- Project changed from Hammer CLI to Foreman

- Category changed from Hosts to Compute resources - VMware

I'm switching the component to VMWare as this is a server side APl issue. The compute node orchestration fails on update via AP| because it misses
some compute attribute data. Ul works fine because it loads the compute attributes into the form when the page is rendered and then when user hits
update the request is sent with required parameters. In API the only workaround is to send the fill set of current compute attributes with the update
request.

#4 - 06/14/2017 06:00 AM - Tomas Strachota

- Target version setto 115

#5 - 06/14/2017 06:28 AM - Tomas Strachota

Most likely introduced with https://github.com/theforeman/foreman/pull/4146/
oVirt is probably affected too.

#6 - 06/15/2017 04:56 AM - Marek Hulan

- translation missing: en.field_release set to 266

| suppose this is a candidate for 1.15.2 then. Please reset the Release if you disagree.

#7 - 06/15/2017 03:03 PM - Steven Miller
- File production.log added
- File guiheader.txt added

| am seeing the same bug on this provider, even when provisioning a new system from the GUI. I've attached my production logs, along with the final
form data that is submitted when attempting to create a host. On the VMware side the actual VM is created, but then when it hits the "undefined
method" error it rolls back the VMware machine (but not the record within foreman)

#8 - 07/06/2017 08:34 AM - Daniel Lobato Garcia

- translation missing: en.field_release changed from 266 to 276

#9 - 08/08/2017 05:12 AM - Daniel Lobato Garcia

- translation missing: en.field_release changed from 276 to 287

#10 - 09/11/2017 01:28 PM - Marek Hulan
Tomas, why do you think it was introduced by the linked PR? According to the trace, it seems that compute_attrs for a given VM are nil. Based on
incoming parameters, they are part of API request. | don't see how attributes can become nil so far

Parameters: {"host"=>{"environment_id"=>20, "compute_attributes"=>{"volumes_attributes"=>{}}, "host_parameters
_attributes"=>{}, "interfaces_attributes"=>{}}, "apiv"=>"v2", "id"=>"119"}

#11 - 09/13/2017 08:35 AM - Tomas Strachota

Marek, the issue has actually been there even before the commit | mentioned, but this change eventually exposed the buggy code to users:
https://github.com/theforeman/foreman/pull/4146/files#diff-4443c0de1e4e867a30d3c878b9cb64e9R24

Before that it wasn't possible to update attribute of existing VMs on vmWare. From the traceback, the process fails on:
https://github.com/theforeman/foreman/blob/c952c782adac290fd5a1145090380424665f5fe 1/app/models/compute_resources/foreman/model/vmware
rb#1434

(please note that the bug was reported against the foreman 1.15 and line numbers have been shifted since then)

So the issue isn't caused by compute_attributes being nil, but by volume attributes that can't be found. The code isn't prepared for partial updates and
always requires the full set of compute attributes (including volumes and nics). The reason it works in the Ul is that the host edit form pre-loads
current compute attributes and therefore the attributes are complete.

#12 - 09/13/2017 09:08 AM - Marek Hulan

- translation missing: en.field_release deleted (287)

Now that makes more sense, thanks for clarification. | suppose this is API RFE then, removing from 1.15.4
https://github.com/theforeman/foreman/pull/4146/files#diff-4443c0de1e4e867a30d3c878b9cb64e9R24
https://github.com/theforeman/foreman/blob/c952c782adac290fd5a1145090380424665f5fe1/app/models/compute_resources/foreman/model/vmware.rb#L434
https://github.com/theforeman/foreman/blob/c952c782adac290fd5a1145090380424665f5fe1/app/models/compute_resources/foreman/model/vmware.rb#L434

#13 - 10/18/2017 05:30 PM - Bhanu Prasad Ganguru

Hi, we recently updated foreman to 1.15.6
And still seeing the same issue
is there a solution for this issue?

Bhanu

#15 - 11/21/2017 07:29 AM - Adam Winberg

Im not using hammer, but the workaround | use when using the API is to first do a GET to get the nodes 'vm_compute_attributes' and then attach that
result to my PUT operation on the node.

In perl (just to get the idea):
my $client = REST::Client->new();
Sclient—->setHost ($foreman_host) ;

# Get compute attributes, bug workaround:
# http://projects.theforeman.org/issues/19990
Sclient—->GET ("/api/hosts/$fgdn/vm_compute_attributes", S$headers);

my S$compute_attrs = decode_json($client->responseContent ());
# Set the attributes for a new host
my %json_data = (
host => {
comment => "Updating the comment attribute",
compute_attributes => $compute_attrs,
}
)i

# Translate the perl hash in Jjson notation
my $data = encode_json (\%$json_data);

# Update parameter
Sclient—->PUT ("/api/hosts/$fgdn", ($data, Sheaders));

I'm not using hammer though...

#16 - 01/05/2018 03:16 PM - Steven Miller

| recently upgraded my environment to 1.16.0 and still found the issue. | was able to eliminate the issue by commenting out the following line in line
457 of the app/models/compute_resources/foreman/model/vmware.rb (the line in the 1.16.0 codebase). | may submit a pull request at some point,
but want to do a little more research to make sure this doesn't break anything unexpected. For us this fixes compute creating through the Ul and API.

450 def save_vm(uuid, attr)

451 vm = find_vm_by_uuid (uuid)

452 vm.attributes.merge! (attr.deep_symbolize_keys)

453 #volumes are not part of vm.attributes so we have to set them seperately if needed
454 if attr.has_key? (:volumes_attributes)

455 vm.volumes.each do |vm_volume |

456 volume_attrs = attr[:volumes_attributes].values.detect {|vol| vol[:id] == vm_volume.id}
457 #vm_volume.size_gb = volume_attrs[:size_gb]

458 end

459 end

460 vI.save

461 end

#17 - 01/05/2018 03:18 PM - Steven Miller

Forgot to mention that it appears the Ul is passing the parameter "sizeGb" to specify volume size. It appear the older, non-React Ul code still uses
that parameter, but the newer view code does not...maybe...

#18 - 01/19/2018 11:17 AM - Marek Hulan
- Status changed from New to Need more information

- Priority changed from High to Normal

The patch would disable the volume size adjusting. What | did not fully understand was the last comment, do you say that you are now able to
reproduce this bug even using UI? The new react implementation work the same way.
#19 - 01/19/2018 02:28 PM - Steven Miller
- File foremanpost-smiller-20180119.txt added

The patch | submitted is the only way we could foreman to work. The hard drive size is still set correctly, even with this line completely commented
out. | have a more sophisticated patch that will check if size_gb is set, and if it is not, then just skip the assignment (line 457 in the example).

In our 1.16 install, the "size_gb" parameter is never passed through the web interface, and seems to break at this line. I've attached

"foremanpost-smiller-20180119.txt", which contains all the POSTed variables from a web browser doing a VMware deployment (on a 1.16 install). |
see that both "size" and "SizeGB" are set within the host[compute_attributes][scsi_controllers] attribute. | don't see a size_gb set on the Ul end at

least.

#20 - 04/05/2018 05:00 PM - Dmitry Okun

Steven Miller wrote:

The patch | submitted is the only way we could foreman to work. The hard drive size is still set correctly, even with this line completely
commented out. | have a more sophisticated patch that will check if size_gb is set, and if it is not, then just skip the assignment (line 457 in the

example).

In our 1.16 install, the "size_gb" parameter is never passed through the web interface, and seems to break at this line. I've attached
"foremanpost-smiller-20180119.txt", which contains all the POSTed variables from a web browser doing a VMware deployment (on a 1.16
install). | see that both "size" and "SizeGB" are set within the host[compute_attributes][scsi_controllers] attribute. | don't see a size_gb set on

the Ul end at least.

| was also hitting the same error when attempting to provision a VMware VM. Moreover, my VMs were created and right away deleted via foreman.

By commenting these lines out, | was able to create VMs via Foreman

#21 - 05/17/2018 12:59 PM - Steven Miller
- Pull request https://github.com/theforeman/foreman/pull/5577 added

Created a pull request for a slightly more sophisticated version of my fix. If volume_attrs is present as a has it will attempt to set size_gb, otherwise it

will skip the assignment. Internal testing seems to work for us (both Ul and API usage)

#22 - 05/21/2018 05:42 PM - The Foreman Bot

- Status changed from Need more information to Ready For Testing

#23 - 05/30/2018 02:35 PM - Tomer Brisker
- Bugzilla link set to 1551014

#24 - 05/31/2018 07:35 AM - The Foreman Bot
- Assignee set to Ondrej PraZzak

- Pull request https://github.com/theforeman/foreman/pull/5626 added

#25 - 05/31/2018 07:40 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/5627 added

#26 - 05/31/2018 07:44 AM - Daniel Lobato Garcia

- translation missing: en.field_release set to 330

#27 - 05/31/2018 07:47 AM - Daniel Lobato Garcia
- Copied to Bug #23752: VMWare allow save vm w/o size_gb attr (1.16.2) added

#28 - 05/31/2018 08:01 AM - Anonymous
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 1dbb2c5b319dbab023f3aaa98019d7b9cd0ee8f6.

Files
hammer_cli_debug.log 6.62 KB 06/13/2017 Christian MeiBner
production.log 23.3 KB 06/14/2017 Christian Mei3ner
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/1dbb2c5b319dbab023f3aaa98019d7b9cd0ee8f6

production.log 472 KB 06/15/2017 Steven Miller
guiheader.txt 3.78 KB 06/15/2017 Steven Miller
foremanpost-smiller-20180119.txt 2.83 KB 01/19/2018 Steven Miller
